function plot_sig(U) 
%  plot_sig
%   Representation des valeurs moyennes dans les elements
%   a partir du vecteur des valeurs moyenne sur l'element
%
% appel plot_sig(Sol)  (la fenetre graphique doit etre ouverte avant)
%       en entree Sol : vecteur des valeurs moyennes dimension (nelt)
%
%  H.Oudin
%==========================================================================
global nelt nnode 
global Coord Connec 

maxt=max(U);       % maxi et mini
mint=min(U);
D=(maxt-mint);            
axis equal
hold on 
for iel = 1:nelt        %----- visualisation du maillage
    alpha=(maxt-U(1,iel))/D;     %----- definition des couleurs
    if alpha < 0.25
        red=1; blue=0; green=4*alpha;
    elseif alpha < 0.5
        red=2-4*alpha; blue=0; green=1;
    elseif alpha < 0.75
        red=0; blue=-2+4*alpha; green=1;
    else
        red=0; blue=1; green=4-4*alpha;
    end
    loce=[];            %----- table de localisation pour l'element
    for i=1:nnode 
		  if Connec(iel,i) > 0 loce=[loce,Connec(iel,i)]; end
    end;   
    Pos  = Coord(loce,:);
    X = Pos(:,1);Y = Pos(:,2);
    patch(X,Y,[red, green, blue]);
end
title(['Echelle de couleur du bleu au rouge avec la valeur max = ',num2str(maxt,'%8.2f')])
colorbar
return
